package ru.ifmo.ihouse.smokesensor;

import ru.ifmo.ihouse.Environment;
import ru.ifmo.ihouse.core.Message;
import ru.ifmo.ihouse.core.Messager;
import ru.ifmo.ihouse.core.Sensor;
import ru.ifmo.ihouse.firealarm.FireAlarmControl;

import com.evelopers.unimod.runtime.ControlledObject;

/**
 *   .       
 *     .   
 * @see ru.ifmo.ihouse.core.Sensor
 * @author rgm
 * @version 2.0.0
 */
public class SmokeSensorDevice extends Sensor implements ControlledObject {
	public void launch() {
		start();
	}
	
	/**   */
	private boolean lastState = false;
	
	/*
	 * (non-Javadoc)
	 * @see ru.ifmo.ihouse.core.Sensor#validateSensor()
	 */
	protected void validateSensor() {
		if (Environment.isFireStarted && (lastState != Environment.isFireStarted)) {
			TRACE("  ");
			Message msg = Messager.empty();
			msg.source = id;
			msg.event = FireAlarmControl.F2;
			Messager.send(msg);
		}
		lastState = Environment.isFireStarted;
	}
}
