package ru.ifmo.ihouse.core;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *       ,    .
 *          listener,   
 *   send,      .
 * @author rgm
 * @version 1.0.5
 */
public class Messager {
	
	/**
	 *     .
	 *     .
	 */
	private class MessageImp extends Message {
		protected long id;
		public MessageImp(long id) { this.id = id; }
		/*
		 * (non-Javadoc)
		 * @see ihouse.Message#id()
		 */
		public long id() { return id; }
	}
	
	/**
	 *  ,      
	 *      {@link Messager#addReciever(ru.ifmo.ihouse.core.Messager.IReciever)}
	 *  ,       .
	 */
	public interface IReciever {
		/**
		 *  ,  Messager.
		 * @param msg .
		 */
		public void recieve(Message msg);
	}
	
	/**
	 *  .
	 */
	private ArrayList<IReciever> recievers = new ArrayList<IReciever>();
	
	/**
	 * / .
	 * @param r
	 */
	public void addReciever(IReciever r) {
		recievers.add(r);
	}
	
	/**
	 *    Messager.
	 */
	private static Messager instance = null;
	
	/**
	 *     .
	 * @param msg   .
	 */
	public void raw_send(Message msg) {
		Iterator<IReciever> i = recievers.iterator();
		while (i.hasNext())
			i.next().recieve(msg);
	}
	
	private Messager() {};
	
	/**
	 *    Messager.
	 * @return   Messager.
	 */
	public static Messager instance() {
		if (instance == null)
			instance = new Messager();
		return instance;
	}
	
	/**
	 *  ID 
	 */
	private static long idBase = 0;
	
	/**
	 *    .
	 * @return  .
	 */
	public static Message empty() {
		return instance().new MessageImp(idBase++);
	}
	
	/**
	 *    .
	 * @param msg .
	 */
	public static void send(Message msg) {
		instance().raw_send(msg);
	}
}
