package ru.ifmo.ihouse.devices.sample;

import com.evelopers.unimod.runtime.ControlledObject;

import ru.ifmo.ihouse.core.Device;
import ru.ifmo.ihouse.core.Message;

import com.evelopers.unimod.runtime.context.StateMachineContext;

/**
 * Sample device
 * @author rgm
 *
 */
public class SampleDevice extends Device implements ControlledObject {
	public SampleDevice() {
		super();
		this.message = "Unknown =(";
		//SampleDevice.class.getClassLoader().
		InitAutomata("devices/ru/ifmo/ihouse/devices/sample/A1.xml", this);
		start();
	}
	
	public String message = null;
	public Double version = 0.0;
	
	public SampleDevice(long id, String sampleMessage) {
		super();
		this.message = sampleMessage;
		//SampleDevice.class.getClassLoader().
		InitAutomata("devices/ru/ifmo/ihouse/devices/sample/A1.xml", this);
		start();
	}

	/**
	 * @unimod.action.descr print "Sample message!"
	 */
	public void z1(StateMachineContext context) {
		System.out.println(message + " ver." + version.toString());
	}
	
	public boolean handle(Message msg) {
		if (msg.destination != id) return false;
		super.handle(msg);
		return true;
	}
}
