package ru.ifmo.ihouse;

import java.text.SimpleDateFormat;
import java.util.Calendar;

import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.DateFormatter;

public class Tracer {
	
	private static JTextPane textArea = null;
	
	public static void init(JTextPane ta) {
		textArea = ta; 
	}
	
	public static void TRACE(String str) {
		if (textArea == null) return;
		try {
			textArea.getStyledDocument().insertString(0, SimpleDateFormat.getTimeInstance().format(Calendar.getInstance().getTime()) + ' ' + str + "\n", null);
		} catch (BadLocationException err) {}
	}
	
	public static void ALARM(String str) {
		if (textArea == null) return;
		try {
			textArea.getStyledDocument().insertString(0, SimpleDateFormat.getTimeInstance().format(Calendar.getInstance().getTime()) + ' ' + str + "\n", textArea.getStyle("Red"));
		} catch (BadLocationException err) {}
	}
}
