package ru.ifmo.ihouse.core;

import java.util.HashMap;
import java.util.Iterator;

/**
 *   -   
 *      
 *   . 
 * @author rgm
 * @version 1.0.0
 */
public class DeviceMaster {
	private static HashMap<Device, Long> devices = new HashMap<Device, Long>();
	private static long idbase = 0;
	
	/**
	 *  ID  .
	 * @param device 
	 * @return ID
	 */
	public static long getIDFor(Device device) {
		if (device == null) return -1;
		if (devices.containsKey(device))
			return devices.get(device);
		else {
			idbase++;
			Long id = new Long(idbase); 
			devices.put(device, id);
			return id;
		}
	}
	
	/**
	 *  ID    ,    -1   .
	 * @param name  
	 * @return ID   -1,    .
	 */
	public static long DeviceID(String name) {
		if (name == null) return -1;
		Iterator<java.util.Map.Entry<Device, Long>> i = devices.entrySet().iterator();
		while (i.hasNext()) {
			Device d = i.next().getKey();
			if (name.equals(d.name)) return d.id();
		}
		return -1;
	}
}
